

/*
    BedSlope class

    An OpenSceneGraph viewer for pyVolution .sww files.
    copyright (C) 2004 Geoscience Australia
*/


#ifndef BEDSLOPE_H
#define BEDSLOPE_H


#include <project.h>
#include <SWWReader.h>
#include <osg/Geode>
#include <osg/Material>
#include <osg/StateAttribute>



class BedSlope
{

public:

    BedSlope(SWWReader *sww);
    virtual osg::Geode* get(){ return _node; }
    virtual osg::BoundingBox getBound(){ return _geom->getBound(); }

protected:

    SWWReader* _sww;
    osg::Geode* _node;
    osg::Geometry* _geom;
    osg::StateSet* _stateset;
    osg::Material* _material;
    virtual ~BedSlope(){;}

};


#endif  // BEDSLOPE_H