
#include <osg/Geode>
#include <osg/Geometry>
#include <osg/ShapeDrawable>
#include <osg/Texture2D>
#include <osg/PolygonOffset>
#include <osgDB/Registry>
#include <osgDB/ReadFile>


osg::Geode* createSky(float radius, char* filename)
{
    osg::Geode* geode = new osg::Geode;
    osg::ShapeDrawable* geom = new osg::ShapeDrawable( new osg::Sphere(osg::Vec3(0,0,-radius/4.0),radius) );
    
    // set up the texture state.    
    osg::Texture2D* texture = new osg::Texture2D;
    texture->setDataVariance(osg::Object::DYNAMIC);  // protect from being optimized away as static state.
    texture->setWrap(osg::Texture::WRAP_S, osg::Texture::REPEAT);
    texture->setImage(osgDB::readImageFile(filename));
    
    osg::StateSet* stateset = new osg::StateSet;
    stateset->setTextureAttributeAndModes( 0, texture, osg::StateAttribute::ON );
    stateset->setMode( GL_LIGHTING, osg::StateAttribute::OFF );
    geom->setStateSet( stateset );
 
    geode->addDrawable(geom);
    return geode;
}
