
/*
    WaterSurface class

    An OpenSceneGraph viewer for pyVolution .sww files.
    copyright (C) 2004 Geoscience Australia
*/


#ifndef WATERSURFACE_H
#define WATERSURFACE_H


#include <project.h>
#include <SWWReader.h>
#include <osg/Geode>
#include <osg/Material>
#include <osg/StateAttribute>



class WaterSurface
{

public:

    WaterSurface(SWWReader *sww);
    virtual osg::Geode* get(){ return _node; }
    virtual void setTimeStep( unsigned int ts );
    virtual void toggleWireframe();

protected:

    SWWReader* _sww;
    osg::Geode* _node;
    osg::Geometry* _geom;
    osg::StateSet* _stateset;
    osg::Material* _material;
    virtual ~WaterSurface();

};


#endif  // WATERSURFACE_H